
if FindRdap.verbose do
  IO.puts("Starting")
end
HTTPoison.start()
expiration = FindRdap.get_expiration()
if FindRdap.verbose do
  if expiration != nil do
    {:ok, e} = DateTime.from_unix(expiration)
    IO.puts("Expiration is #{DateTime.to_string(e)}")
  end
end
database =
if expiration != nil and DateTime.to_unix(DateTime.utc_now()) < expiration do
    if FindRdap.verbose do
      IO.puts("Using the cache #{FindRdap.local_file}")
    end
  db = FindRdap.get_cache()
  if db == nil do
    if FindRdap.verbose do
      IO.puts("Wrong expiration")
    end
    FindRdap.get_iana()
  else
    db
  end
else
  if FindRdap.verbose do
    IO.puts("No expiration known")
  end
  FindRdap.get_iana()
end
if FindRdap.verbose do
  IO.puts("#{database["description"]} published on #{database["publication"]}") 
end
Enum.map(System.argv(),
  fn domain ->
    server = FindRdap.get_server(database, domain)
    json = FindRdap.get_response(server, domain)
    IO.puts(json)
  end)

